package org.numamo.services;

import org.numamo.rcm.car.game.protocols.v2x.resume.GameResumeV2x;
import org.numamo.services.rcm.data.adapter.service.v2x.api.ResumeProcessor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.stereotype.Service;


@SpringBootApplication
public class App {

    private static final Logger LOGGER = LoggerFactory.getLogger(App.class);

    public static void main(String[] args) {
        SpringApplication.run(App.class, args);
        LOGGER.info("Spring context was created: Default encoding: {}", System.getProperty("file.encoding"));
    }


    @Service
    public static final class ResumeProcessorExample implements ResumeProcessor {

        @Override
        public Object process(GameResumeV2x resume) {
            LOGGER.debug("Empty processing of the resume: token={}", resume.getToken());
            return resume;
        }

    }

}
