package org.numamo.services.rcm.data.adapter.controller.v2x.impl;

import org.numamo.services.rcm.data.adapter.model.v2x.dto.ResponseV2x;
import org.numamo.services.rcm.data.adapter.service.v2x.api.RequestControl;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import java.util.Collections;

import static org.numamo.rcm.car.game.protocols.v2x.dto.ResponseStatus.internalServerError;
import static org.slf4j.LoggerFactory.getLogger;


@RestControllerAdvice
public final class ControllerExceptionHandler {


    // Variables and constructors:-------------------------------------------------------
    private static final Logger LOGGER = getLogger(ControllerExceptionHandler.class);

    private final RequestControl requestControl;

    @Autowired
    public ControllerExceptionHandler(RequestControl requestControl) {
        this.requestControl = requestControl;
    }


    // Public API:-----------------------------------------------------------------------
    @ExceptionHandler(Exception.class)
    public ResponseV2x createResponse(final Exception exception) {

        final ResponseV2x response = new ResponseV2x();

        response.setStatus(internalServerError(exception,
                requestControl.getCurrent().getRequestId()));
        response.setReports(Collections.emptyList());

        LOGGER.debug("The following response entity was generated {}\n cause: {}", response, exception);

        return response;
    }


}
