package org.numamo.services.rcm.data.adapter.controller.v2x.impl;

import io.swagger.annotations.Api;
import org.numamo.rcm.car.game.protocols.v2x.dto.resume.info.GetResumeInfoRq;
import org.numamo.rcm.car.game.protocols.v2x.resume.GameResumeV2x;
import org.numamo.services.rcm.data.adapter.controller.v2x.api.KeyWordsResumeController;
import org.numamo.services.rcm.data.adapter.model.v2x.dto.ResponseV2x;
import org.numamo.services.rcm.data.adapter.service.v2x.api.RequestControl;
import org.numamo.services.rcm.data.adapter.service.v2x.api.ResumeProcessorFacade;
import org.numamo.services.rcm.data.adapter.service.v2x.api.ResumeStorageService;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

import static org.numamo.services.rcm.data.adapter.config.PropNames.CALCULATE_RESUMES_BY_KEY_WORDS_V2X;
import static org.slf4j.LoggerFactory.getLogger;


@RestController
@Api(value = CALCULATE_RESUMES_BY_KEY_WORDS_V2X,
        tags = "[1] Requesting and processing the v.2.x RCM data package by keywords")
public final class KeyWordsResumeControllerImpl
        extends AbstractProcessor<GetResumeInfoRq> implements KeyWordsResumeController {

    @Autowired
    public KeyWordsResumeControllerImpl(ResumeProcessorFacade processor,
                                        ResumeStorageService service,
                                        RequestControl control
    ) {
        super(processor, service, control);
    }

    @Override
    public ResponseV2x post(GetResumeInfoRq resumeInfoRq) {
        return process(resumeInfoRq);
    }

    @Override
    Logger makeLogger() {
        return getLogger(KeyWordsResumeControllerImpl.class);
    }

    @Override
    List<GameResumeV2x> findResumes(GetResumeInfoRq request, ResumeStorageService service) {
        return service.getByKeyWords(request.getKeyWord(), request.getModifier());
    }

}
