package org.numamo.services.rcm.data.adapter.controller.v2x.impl;

import io.swagger.annotations.Api;
import org.numamo.rcm.car.game.protocols.v2x.dto.resume.GetResumeRq;
import org.numamo.rcm.car.game.protocols.v2x.resume.GameResumeV2x;
import org.numamo.services.rcm.data.adapter.controller.v2x.api.TokensResumeController;
import org.numamo.services.rcm.data.adapter.model.v2x.dto.ResponseV2x;
import org.numamo.services.rcm.data.adapter.service.v2x.api.RequestControl;
import org.numamo.services.rcm.data.adapter.service.v2x.api.ResumeProcessorFacade;
import org.numamo.services.rcm.data.adapter.service.v2x.api.ResumeStorageService;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

import static org.numamo.services.rcm.data.adapter.config.PropNames.CALCULATE_RESUME_BY_TOKENS_V2X;
import static org.slf4j.LoggerFactory.getLogger;


@RestController
@Api(value = CALCULATE_RESUME_BY_TOKENS_V2X,
        tags = "[2] Requesting and processing the v.2.x RCM data package by tokens")
public final class TokensResumeControllerImpl extends AbstractProcessor<GetResumeRq> implements TokensResumeController {

    @Autowired
    public TokensResumeControllerImpl(ResumeProcessorFacade processor,
                                      ResumeStorageService service,
                                      RequestControl requestControl
    ) {
        super(processor, service, requestControl);
    }

    @Override
    public ResponseV2x post(GetResumeRq resumeInfoRq) {
        return process(resumeInfoRq);
    }

    @Override
    Logger makeLogger() {
        return getLogger(TokensResumeControllerImpl.class);
    }

    @Override
    List<GameResumeV2x> findResumes(GetResumeRq request, ResumeStorageService service) {
        return service.getByTokens(request.getResumeTokens());
    }

}
